package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.PontoDeEntregaPage;

public class PontoDeEntregaFlows {
    PontoDeEntregaPage pontoDeEntregaPage = new PontoDeEntregaPage();
    public void navegaPontoDeEntrega(String acaoTela, String CDFILIAL){
        pontoDeEntregaPage.navegaPontoDeEntrega(acaoTela, CDFILIAL);
    }

    public String confirmaAcessoTela(){return pontoDeEntregaPage.confirmaAcessoTela();}

    public void validarCamposObrigatorios(){pontoDeEntregaPage.validarCamposObrigatorios();}

    public String campoObrigatorioCodigo(){return pontoDeEntregaPage.campoObrigatorioCodigo();}

    public String campoObrigatorioNome(){return pontoDeEntregaPage.campoObrigatorioNome();}

    public void validarCadastroRegistroExistente(){pontoDeEntregaPage.validarRegistrosIguais();}

    public void cadastrarPontoEntrega(String NMPONTOENTREGA, String ENDEPONTOENTREGA){pontoDeEntregaPage.dadosPontoEntrega(NMPONTOENTREGA,ENDEPONTOENTREGA);}

    public String validaCadastroCodigoPontoEntrega(){return pontoDeEntregaPage.validaCadastroCodigoPontoEntrega();}

    public String validaCadastroNomePontoEntrega(){return pontoDeEntregaPage.validaCadastroNomePontoEntrega();}

    public String validaCadastroEnderecoPontoEntrega(){return pontoDeEntregaPage.validaCadastroEnderecoPontoEntrega();}

    public String validarCadastroCodigoPontoEntrega(){return pontoDeEntregaPage.validarCadastroCodigoPontoEntrega();}

    public String validarCadastroNomePontoEntrega(){return pontoDeEntregaPage.validarCadastroNomePontoEntrega();}

    public String validarCadastroEnderecoPontoEntrega(){return pontoDeEntregaPage.validarCadastroEnderecoPontoEntrega();}

    public void alteraPontoDeEntrega(String NMPONTO002,String ENDEPONTO002,String NMEPONTO003,String ENDPONTO003){
        pontoDeEntregaPage.alteraPontoDeEntrega(NMPONTO002,ENDEPONTO002,NMEPONTO003,ENDPONTO003);
    }

    public String nomeEditado002(){return pontoDeEntregaPage.nomeEditado002();}

    public String enderecoEditado002(){return pontoDeEntregaPage.enderecoEditado002();}

    public String nomeEditado003(){return pontoDeEntregaPage.nomeEditado003();}

    public String enderecoEditado003(){return pontoDeEntregaPage.enderecoEditado003();}

    public void excluirPontoDeEntrega(){
        pontoDeEntregaPage.apagaPontoDeEntrega();
    }

    public String validarExclusao(){return pontoDeEntregaPage.validaExclusao();}


}
