package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;

public class FrequenciaPratoMesSemanaPage extends PageBase {

    By clicaMenu = By.xpath("//*[@id='header']/div[1]/div[2]/div[1]/a");
    By msgEncontrada = By.xpath("//*[@id='header']/div/div[2]/div[3]");
    By procurarTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Frequência de Pratos no Mês/Semana']");
    By tipoContrato = By.xpath("//div[@data-zh-id='11923801703985460015602']/div[2]");
    By opcaoPlanejado = By.xpath("//li[text() = 'Planejado']");
    By limpaFiltroUnidade = By.xpath("//span[@zh-icon='no-border close-x']");
    By buscaUnidade = By.xpath("//*[@zh-icon='no-border search']");
    By informaBusca = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[1]");
    By btnAplicarFiltro = By.xpath("//*[text() = 'Aplicar filtro']");

    //Vigência Frequência
    By btnAdicionar = By.xpath("//li[@data-zh-id='11923801701325286569119']");
    By adicionarPrato = By.xpath("//li[@data-zh-id='119238017026759973331049']");
    By adicionarServico = By.xpath("//li[@data-zh-id='1192380170130550384940']");

    By abaVigenciaContrato = By.xpath("//a[text() = 'Vigência de Contrato']");
    By vigenciaInicial = By.xpath("//div[@name = 'DTVIGENCIA']");
    By vigenciaFinal = By.xpath("//div[@name = 'DTVIGENCIAFIM']");
    By mesInicial = By.xpath("//div[@class = 'month']//div[text() = 'Nov']");
    By mesFinal = By.xpath("//div[@class = 'month']//div[text() = 'Dez']");
    By campoDescricao = By.xpath("//input[@name = 'DESCRICAO']");
    By observacaoUnidade = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[4]/div/div/div[3]");
    By selecionaObservacao = By.xpath("//li[text() = 'Unidade para deposito de produtos']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By btnSalvarVigencia = By.xpath("//li[@data-zh-id='11923801704291496304754']");

    //Serviço
    By abaServicos = By.xpath("//a[text() = 'Serviços']");
    By btnadicionarServico = By.xpath("//li[@data-zh-id='1192380170130550384940']");
    By selecionaServico = By.xpath("//*[@id='grid-119238017025958207931055']/div[2]/div/div[2]/div[1]");
    By mensagemAlertOk = By.xpath("//button[@class = 'zh-alert-button']");
    By buscaPrato = By.xpath("//span[@zh-icon='no-border search']");
    By buscaServico = By.xpath("//*[@zh-icon='no-border search']");
    By minimoInsercaoMes = By.xpath("//input[@name = 'NRMINFREQPRATMES']");
    By maximoInsercaoMes = By.xpath("//input[@name = 'NRMAXFREQPRATMES']");
    By maximoInsercaoSemana = By.xpath("//input[@name = 'NRMAXFREQPRATSEM']");
    By btnSalvarProximo = By.xpath("//span[text() = 'Salvar e Próximo']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");

    By mensagemEncontrada = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[2]");
    By msgmEncontrada = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[2]");

    //Ações para editar Serviço

    By clicarFrequencia = By.xpath("//*[@id='grid-1192380170133714118925']/div[2]/div/div[1]");
    By clicarServico = By.xpath("//*[@id='grid-1192380170109538483226']/div[2]/div/div");
    By clicaMinInsercoesMesArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[4]/div");
    By valorAtuaMinlInsercoesMesArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[4]/div/input");
    By clicaMaxInsercoesMesArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[5]/div");
    By valorAtualMaxInsercoesMesArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[5]/div/input");
    By clicaMaxInsercoesSemanaArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[6]/div");
    By valorAtualMazInsercoesSemanaArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[6]/div/input");

    By clicaMinInsercoesMesStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[4]/div");
    By valorAtuaMinlInsercoesMesStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[4]/div/input");
    By clicaMaxInsercoesMesStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[5]/div");
    By valorAtualMaxInsercoesMesStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[5]/div/input");
    By clicaMaxInsercoesSemanaStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[6]/div");
    By valorAtualMazInsercoesSemanaStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[6]/div/input");
    By btnSalvarAlteracoes = By.xpath("//span[text() = 'Salvar alterações']");
    By btnEditarVigencia = By.xpath("//li[@data-zh-id='11923801701382027082121']");
    By limpaVigenciaFinal = By.xpath("//div[@id = 'DTVIGENCIAFIM']//span[@zh-icon='no-border close-x']");

    By msgEsperadaminInsercaoArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[4]/span");
    By msgEsperadamaxInsercaoArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[5]/span");
    By msgEsperadamaxInsercaoSemanaArroz = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[1]/div[6]/span");
    By msgEsperadaminInsercaoStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[4]/span");
    By msgEsperadamaxInsercaoStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[5]/span");
    By msgEsperadamazInsercaoSemanaStrogonoff = By.xpath("//*[@id='grid-119238017013364634571030']/div[2]/div/div[2]/div[6]/span");
    By msgEsperadaDescricaoVigencia = By.xpath("//*[@id='span-field-DESCRICAO']/p");


    //Relatórios
    By btnRelatorio = By.xpath("//span[text() = 'Relatórios']");
    By agrupamentoUnidades = By.xpath("//div[@id = 'NMGRUPFILI']/span");
    By checkBoxTodasUnidades = By.xpath("//label[@for='zh-checkbox-NMFILIAL_ALL']/div[1]");
    By campoUnidade = By.xpath("//div[@id = 'CDFILIAL']");
    By selecionaRegistros = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]");
    By checkBoxTodosServicos = By.xpath("//label[@for='zh-checkbox-NMSERVICO_ALL']/div[1]");
    By campoServicos = By.xpath("//div[@id = 'NMSERVICO']");
    By dtVigenciaInicial = By.xpath("//div[@id = 'DTVIGINI']");
    By mesInicialVigencia = By.xpath("//div[@class = 'month']//div[text() = 'Jan']");
    By dtVigenciaFinal = By.xpath("//div[@id = 'DTVIGFIN']");
    By mesFinalVigencia = By.xpath("//div[@class = 'month']//div[text() = 'Dez']");
    By confirmaEmissaoRelVigencia = By.xpath("//span[text() = 'Confirmar']");


    //Botão ações aba vigência

    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By opcaoExportarVigencia = By.xpath("//span[text() = 'Exportar Vigência']");
    By opcaoExportarDadosParaUnidades = By.xpath("//span[text() = 'Exportar dados da vigência para outras Unidades']");
    By checkBoxExportarVigencia = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By btnConfirmarExportar = By.xpath("//span[text() = 'Confirmar']");
    By alertMensagemConfirma = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'Sim']");
    By unidadeDestino = By.xpath("//div[@name = 'NMFILIALDEST']");
    By marcaUnidadesDestino = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]");
    By checkBoxExportarAnexo = By.xpath("//label[@for='zh-checkbox-ANEXO']/div[1]");
    By opcapAcrescentar = By.xpath("//label[@for='radio-TPOPER-A']/div[1]");
    By opcaoSobrepor = By.xpath("//label[@for='radio-TPOPER-S']/div[1]");

    //Importar Serviço

    By importarServicos = By.xpath("//span[text() = 'Importar Serviços']");
    By buscaVigencia = By.xpath("//div[@id = 'DTVIGENCIA_FORMATADA']//span[@zh-icon='no-border search']");
    By campoServico = By.xpath("//*[@name = 'NMSERVICO']");
    By selecionaServicoImportacao = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]");
    By servicoImportacaoSobrepor = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]");
    By btnOk = By.xpath("//*[text() = 'Ok']");
    By radioButtonAcrescentar = By.xpath("//label[@for = 'radio-TPOPER-A']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By radioButtonSobrepor = By.xpath("//label[@for = 'radio-TPOPER-S']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By btnConfirmarImportacao = By.xpath("//span[text() = 'Confirmar']");
    By confirmarImportacao = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'Sim']");
    By msgEncontrada_1 = By.xpath("//*[@id='grid-1192380170109538483226']/div[2]/div/div[1]/div[2]/span");
    By msgEncontrada_2 = By.xpath("//*[@id='grid-1192380170109538483226']/div[2]/div/div[2]/div[2]/span");
    By msgEncontrada_3 = By.xpath("//*[@id='grid-1192380170109538483226']/div[2]/div/div/div[2]/span");


    //Exclusão de serviço e vigência

    By marcaCheckBoxServico = By.xpath("//*[@id='grid-1192380170109538483226']/div[1]/div/div/div[1]");
    By btnExcluirServico = By.xpath("//li[@data-zh-id='1192380170316240067044']");
    By msgEncontrada_4 = By.xpath("//p[text() = 'Não há registros']");
    By btnExcluirVigencia = By.xpath("//li[@data-zh-id='1192380170230510319123']");
    By confirmarExclusao = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'Sim']");
    By alertSucessoExclusao = By.xpath("//*[@class='zh-notification-messages']");




    public void acessarTela() {
        waitForElement(msgEncontrada);
        click(clicaMenu);
        tempo();
        click(procurarTela);
        clearAndSendKeys(procurarTela, "Frequência de Pratos no Mês/Semana");
        tempo();
        click(selecionaTela);
        tempo();
    }

    public void realizarFiltro(String nomeOpcao, String CDFILIAL) {
        if (nomeOpcao == "Planejado") {
            click(tipoContrato);
            tempo();
            click(opcaoPlanejado);
            tempo();
            click(limpaFiltroUnidade);
            click(buscaUnidade);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, CDFILIAL);
            tempo();
            click(selecionaBusca);
            tempo();
            click(btnAplicarFiltro);
            tempo();
        } else {
            click(limpaFiltroUnidade);
            click(buscaUnidade);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, CDFILIAL);
            tempo();
            click(selecionaBusca);
            tempo();
            click(btnAplicarFiltro);
            tempo();
        }
    }

    public void validaCamposObrigatirios() {
        click(btnAdicionar);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void realizarCadastro() {
        clickPerform(vigenciaInicial);
        tempo();
        click(mesInicial);
        tempo();
        click(vigenciaFinal);
        tempo();
        click(mesFinal);
        tempo();
        click(campoDescricao);
        clearAndSendKeys(campoDescricao, "TESTE AUTOMAÇÃO");
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(observacaoUnidade), -200, 0).click().build().perform();
        click(selecionaObservacao);
        tempo();
        click(btnSalvar);
        tempo();

    }

    public void relacionaServico() {
        tempo();
        click(mensagemAlertOk);
        tempo();
        click(selecionaServico);
        tempo();
        click(mensagemAlertOk);
        tempo();
        click(buscaPrato);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca, "000000000");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvarProximo);
        tempo();
        clickPerform(minimoInsercaoMes);
        clearAndSendKeys(minimoInsercaoMes, "1");
        clickPerform(maximoInsercaoMes);
        clearAndSendKeys(maximoInsercaoMes, "2");
        clickPerform(maximoInsercaoSemana);
        clearAndSendKeys(maximoInsercaoSemana, "1");
        click(btnSalvarProximo);
        tempo();
        click(buscaPrato);
        click(informaBusca);
        clearAndSendKeys(informaBusca, "000100000");
        tempo();
        click(selecionaBusca);
        click(btnSalvarProximo);
        tempo();
        clickPerform(minimoInsercaoMes);
        clearAndSendKeys(minimoInsercaoMes, "1");
        clickPerform(maximoInsercaoMes);
        clearAndSendKeys(maximoInsercaoMes, "2");
        clickPerform(maximoInsercaoSemana);
        clearAndSendKeys(maximoInsercaoSemana, "1");
        tempo();
        click(btnSalvarProximo);
        tempo();
        click(btnCancelar);
        tempo();
    }

    public String retornaCadastroArroz() {
        return getText(mensagemEncontrada);
    }

    public String retornaCadatroStrogonoff() {
        return getText(msgmEncontrada);
    }

    public void validaRegistrosIguais() {
        click(adicionarPrato);
        tempo();
        click(buscaPrato);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca, "000000000");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvarProximo);
        tempo();
        clickPerform(minimoInsercaoMes);
        clearAndSendKeys(minimoInsercaoMes, "5");
        clickPerform(maximoInsercaoMes);
        clearAndSendKeys(maximoInsercaoMes, "5");
        clickPerform(maximoInsercaoSemana);
        clearAndSendKeys(maximoInsercaoSemana, "5");
        click(btnSalvarProximo);
        tempo();
        click(mensagemAlertOk);
        tempo();
        click(btnCancelar);
        click(btnVoltar);
        tempo();
        click(adicionarServico);
        tempo();
        click(selecionaServico);
        tempo();
        click(mensagemAlertOk);
        tempo();
        click(btnCancelar);


    }

    public void editarFrequencia() {
        tempo();
        click(clicarFrequencia);
        tempo();
        click(clicarServico);
        tempo();
        click(clicaMinInsercoesMesArroz);
        clearAndSendKeys(valorAtuaMinlInsercoesMesArroz, "5");
        click(clicaMaxInsercoesMesArroz);
        click(btnSalvarAlteracoes);
        tempo();
        click(mensagemAlertOk);
        tempo();
        click(clicaMaxInsercoesMesArroz);
        clearAndSendKeys(valorAtualMaxInsercoesMesArroz, "5");
        click(clicaMaxInsercoesSemanaArroz);
        clearAndSendKeys(valorAtualMazInsercoesSemanaArroz, "5");
        click(clicaMinInsercoesMesStrogonoff);
        clearAndSendKeys(valorAtuaMinlInsercoesMesStrogonoff, "2");
        click(clicaMaxInsercoesMesStrogonoff);
        clearAndSendKeys(valorAtualMaxInsercoesMesStrogonoff, "3");
        click(clicaMaxInsercoesSemanaStrogonoff);
        clearAndSendKeys(valorAtualMazInsercoesSemanaStrogonoff, "2");
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
    }

    public void editarVigenciaFrequencia() {
        click(abaVigenciaContrato);
        tempo();
        click(btnEditarVigencia);
        tempo();
        click(campoDescricao);
        clearAndSendKeys(campoDescricao, "VIGENCIA AUTOMAÇÃO");
        tempo();
        click(limpaVigenciaFinal);
        click(vigenciaFinal);
        tempo();
        click(mesInicial);
        tempo();
        click(btnSalvar);
        tempo();

    }

    public String retornaMinInsercaoArroz() {
        return getText(msgEsperadaminInsercaoArroz);
    }

    public String retornaMaxInsercaoArroz() {
        return getText(msgEsperadamaxInsercaoArroz);
    }

    public String retornaMaxInsercaoSemanaArroz() {
        return getText(msgEsperadamaxInsercaoSemanaArroz);
    }

    public String retornaMinInsercaoStrogonoff() {
        return getText(msgEsperadaminInsercaoStrogonoff);
    }

    public String retornaMaxInsercaoStrogonoff() {
        return getText(msgEsperadamaxInsercaoStrogonoff);
    }

    public String retornaMaxInsercaoSemanaStrogonoff() {
        return getText(msgEsperadamazInsercaoSemanaStrogonoff);
    }

    public String retornaDescricaoAlterada() {
        return getText(msgEsperadaDescricaoVigencia);
    }

    public void importarServico(String nome) {
        tempo();
        click(clicarFrequencia);
        tempo();
        click(abaServicos);
        tempo();
        click(importarServicos);
        tempo();
        click(buscaVigencia);
        tempo();
       /* click(informaBusca);
        clearAndSendKeys(informaBusca,"Janeiro/2023");
        tempo();*/
        click(selecionaBusca);
        tempo();
        click(campoServico);
        tempo();
       /* click(informaBusca);
        clearAndSendKeys(informaBusca,"00003");
        tempo();*/
        if (nome == "Sobrepor"){
            click(servicoImportacaoSobrepor);
            click(btnOk);
            tempo();
            click(radioButtonSobrepor);
        }else {
            click(selecionaServicoImportacao);
            click(btnOk);
            tempo();
            click(radioButtonAcrescentar);
        }
        tempo();
        click(btnConfirmarImportacao);
        tempo();
        click(confirmarImportacao);
        tempo();

    }

    public void exportarVigencia(){
        tempo();
        click(clicarFrequencia);
        tempo();
        click(abaVigenciaContrato);
        tempo();
        click(btnAcoes);
        tempo();
        click(opcaoExportarVigencia);
        tempo();
        click(checkBoxExportarVigencia);
        tempo();
        click(alertMensagemConfirma);
        tempo();
        click(btnConfirmarExportar);
        tempo();
        click(alertMensagemConfirma);
        tempo();
    }

    public void exportarVigenciaUnidades(String tipoExportacao){
        tempo();
        click(clicarFrequencia);
        tempo();
        click(abaVigenciaContrato);
        tempo();
        click(btnAcoes);
        tempo();
        click(opcaoExportarDadosParaUnidades);
        tempo();
        click(unidadeDestino);
        tempo();
        click(marcaUnidadesDestino);
        click(btnOk);
        tempo();
        click(checkBoxExportarAnexo);
        tempo();
        if (tipoExportacao == "Acrescentar" ){
        click(btnConfirmarExportar);
        tempo();
        }else{
            click(opcaoSobrepor);
            click(btnConfirmarExportar);
            tempo();

        }
    }

    public String retornaServicoAlmoco(){return getText(msgEncontrada_1);}

    public String retornaServicoJanta(){
        return getText(msgEncontrada_3);

    }


    public void excluirServico(){
        tempo();
        click(clicarFrequencia);
        tempo();
        click(abaServicos);
        tempo();
        click(marcaCheckBoxServico);
        click(btnExcluirServico);
        tempo();
        click(confirmarExclusao);
        tempo();

    }

    public void excluirVigencia(){
        tempo();
        click(clicarFrequencia);
        tempo();
        click(abaVigenciaContrato);
        tempo();
        click(btnExcluirVigencia);
        tempo();
        click(confirmarExclusao);
        tempo();

    }

    public String validarExclusao(String abaExclusao){
        if (abaExclusao == "Serviço"){
            return getText(msgEncontrada_4);
        }else
            return getText(alertSucessoExclusao);
    }

    public void emiteRelatorio(){
        tempo();
        click(btnRelatorio);
        tempo();
        click(agrupamentoUnidades);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0000000002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(campoUnidade);
        tempo();
        click(selecionaRegistros);
        click(btnOk);
        tempo();
        click(campoServicos);
        tempo();
        click(selecionaRegistros);
        click(btnOk);
        tempo();
        click(dtVigenciaInicial);
        tempo();
        click(mesInicialVigencia);
        tempo();
        click(dtVigenciaFinal);
        tempo();
        click(mesFinalVigencia);
        tempo();
        click(confirmaEmissaoRelVigencia);
        tempo();
        click(confirmaEmissaoRelVigencia);
        tempo();

    }








}
