package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

public class NutrientesPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoNutrientes = By.xpath("//section[@class='something-else']//span[text() = 'Nutrientes']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"232554219839611045356\"]//div[@class=\"zh-test-box\"]");
    By campoCodigo = By.id("CDNUTRIENTE");
    By campoNome = By.id("NMNUTRIENTE");
    By campoSigla = By.id("NMREDUZIDO");
    By campoOrdem = By.id("NRORDEMNUTR");
    By campoGrupo = By.id("NMGRUPNUTR");
    By campoFatCalcCaloria = By.id("VRFATORNUTR");
    By inputCheckBoxECaloria = By.id("zh-checkbox-IDKCAL");
    By inputCheckBoxCalCaloria = By.id("zh-checkbox-IDCALORIAS");
    By inputCheckBoxImpressao = By.id("zh-checkbox-IDNUTRRELEV");
    By checkBoxImpressao = By.xpath("//label[@for=\"zh-checkbox-IDNUTRRELEV\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"232554219269003067337\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"2325542191218599811341\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioSigla = By.xpath("//div[@data-zh-id=\"2325542193883671384342\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUn = By.xpath("//div[@data-zh-id=\"2325542191924533084343\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioOrdem = By.xpath("//div[@data-zh-id=\"2325542192973821237346\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioGrupo = By.xpath("//div[@data-zh-id=\"2325542193009240775347\"]//div[@class=\"zh-validation\"]/span");

    By botaoCampoUn = By.xpath("//div[@id='SGUNIDADE']//span[@style=\"background-image: none; display: block;\"]");
    By botaoSalvar = By.xpath("//div[@id=\"footer\"]//span[text() = 'Salvar']");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By botaoEditarNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@class=\"zh-grid-actions\"]/span[1]");
    By botaoExcluirNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@class=\"zh-grid-actions\"]/span[2]");
    By codigoNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDNUTRIENTE\"]/span");
    By nomeNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMNUTRIENTE\"]/span");
    By siglaNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMREDUZIDO\"]/span");
    By unidadeNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By orderNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRORDEMNUTR\"]/span");
    By grupoNutrienteLinha1 = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMGRUPNUTR\"]/span");

    By campoProcurarUnidade = By.xpath("//section[@class=\"popup-content\"]//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By unMiligrama = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'MILIGRAMA']");
    By unMiligramaCapsula = By.xpath("//div[@id=\"grid-9000\"]//span[text() = 'MILIGRAMA/CAPSULA']");

    By grupoCarboidratos = By.xpath("//div[@data-zh-id='2325542193009240775347']//span[text() = '01 | CARBOIDRATOS']");
    By grupoGorduras = By.xpath("//div[@data-zh-id='2325542193009240775347']//span[text() = '03 | GORDURAS']");
    By grupoSais = By.xpath("//div[@data-zh-id='2325542193009240775347']//span[text() = '06 | SAIS MINERAIS']");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemNenhumRegistroEncontrado = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");


    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Nutrientes");
        click(selecionarOpcaoNutrientes);
    }

    public void adicionarNutriente() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        tempo();
        sendKeys(campoCodigo, "40");
        sendKeys(campoNome, "LIPÍDIOS");
        sendKeys(campoSigla, "LIP");
        click(botaoCampoUn);
        sendKeys(campoProcurarUnidade, "MILIGRAMA");
        click(unMiligrama);
        clicarCampoSelecionarValor(campoGrupo, grupoGorduras);
        click(checkBoxImpressao);
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso exibida no canto superior direito após adicionar um nutriente");
    }

    public void verificarNutrienteAdicionado() {
        preencherCampoProcurarTelaInicial("040");

        //valores esperados
        String expCodigo = "040";
        String expNome = "LIPÍDIOS";
        String expSigla = "LIP";
        String expUnidade = "MG";
        String expOrdem = "22";
        String expGrupo = "GORDURAS";

        //valores encontrados
        String encCodigo = getText(codigoNutrienteLinha1);
        String encNome = getText(nomeNutrienteLinha1);
        String encSigla = getText(siglaNutrienteLinha1);
        String encUnidade = getText(unidadeNutrienteLinha1);
        String encOrdem = getText(orderNutrienteLinha1);
        String encGrupo = getText(grupoNutrienteLinha1);

        Assert.assertEquals(encCodigo, expCodigo, "Verificação código do nutriente adicionado");
        Assert.assertEquals(encNome, expNome, "Verificação nome do nutriente adicionado");
        Assert.assertEquals(encSigla, expSigla, "Verificação sigla do nutriente adicionado");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação unidade do nutriente adicionado");
        Assert.assertEquals(encOrdem, expOrdem, "Verificação ordem do nutriente adicionado");
        Assert.assertEquals(encGrupo, expGrupo, "Verificação grupo do nutriente adicionado");

        click(nomeNutrienteLinha1);
        click(botaoEditarNutrienteLinha1);
        boolean impressao = returnIfElementIsSelected(inputCheckBoxImpressao);
        Assert.assertEquals(impressao, true, "Verificar se o chack-box continuou selecionado após adicionar o nutriente");
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void editarNutriente() {
        preencherCampoProcurarTelaInicial("020");
        click(botaoEditarNutrienteLinha1);

        boolean codigoHabilitado = returnIfElementIsEnabled(campoCodigo);
        Assert.assertEquals(codigoHabilitado, false, "Verificar se durante a edição o campo código está desabilitado");

        clearAndSendKeys(campoNome, "GORDURA");
        clearAndSendKeys(campoSigla, "G");
        click(botaoCampoUn);
        click(botaoCampoUn);
        sendKeys(campoProcurarUnidade, "MILIGRAMA/CAPSULA");
        click(unMiligramaCapsula);
        clearAndSendKeys(campoOrdem, "30");
        clicarCampoSelecionarValor(campoGrupo, grupoSais);
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso exibida no canto superior direito, após editar o nutriente");
        click(botaoVoltar);

        //valores esperados
        String expCodigo = "020";
        String expNome = "GORDURA";
        String expSigla = "G";
        String expUnidade = "MG/CAP";
        String expOrdem = "30";
        String expGrupo = "SAIS MINERAIS";

        //valores encontrados
        String encCodigo = getText(codigoNutrienteLinha1);
        String encNome = getText(nomeNutrienteLinha1);
        String encSigla = getText(siglaNutrienteLinha1);
        String encUnidade = getText(unidadeNutrienteLinha1);
        String encOrdem = getText(orderNutrienteLinha1);
        String encGrupo = getText(grupoNutrienteLinha1);

        Assert.assertEquals(encCodigo, expCodigo, "Verificação código do nutriente após a edição");
        Assert.assertEquals(encNome, expNome, "Verificação nome do nutriente após a edição");
        Assert.assertEquals(encSigla, expSigla, "Verificação sigla do nutriente após a edição");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação unidade do nutriente após a edição");
        Assert.assertEquals(encOrdem, expOrdem, "Verificação ordem do nutriente após a edição");
        Assert.assertEquals(encGrupo, expGrupo, "Verificação grupo do nutriente após a edição");

        retornarValeresDoNutrienteAntesEdicao();
    }

    public void excluirNutriente() {
        preencherCampoProcurarTelaInicial("040");
        click(botaoExcluirNutrienteLinha1);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o nutriente");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Excluído com sucesso.", "Verificar mensagem de excluído com sucesso exibida no canto superior direito da tela após excluir o nutriente");

        mensagem = getText(mensagemNenhumRegistroEncontrado);
        mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no grid da lista de nutrientes, informando que nenhum registro foi encontrado, após a exclusão do nutriente");
    }

    public void camposObrigatoriosAdicionar() {
        tempo();
        click(botaoAdicionar);
        clear(campoOrdem);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A ordem não deve ser decimal.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida na tela após limpar o campo ordem");
        click(botaoOk);
        tempo();
        click(botaoSalvar);

        //mensagens encontrados nos campo obrigatórios
        String codigo = getText(mensagemObrigatorioCodigo);
        String nome = getText(mensagemObrigatorioNome);
        String sigla = getText(mensagemObrigatorioSigla);
        String unidade = getText(mensagemObrigatorioUn);
        String ordem = getText(mensagemObrigatorioOrdem);
        String grupo = getText(mensagemObrigatorioGrupo);

        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo código");
        Assert.assertEquals(nome, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo nome");
        Assert.assertEquals(sigla, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo sigla");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo unidade");
        Assert.assertEquals(ordem, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo ordem");
        Assert.assertEquals(grupo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo grupo");
    }

    public void camposObrigatoriosEditar() {
        preencherCampoProcurarTelaInicial("021");
        click(botaoEditarNutrienteLinha1);
        tempo();
        clear(campoNome);
        clear(campoSigla);
        click(botaoCampoUn);

        clear(campoOrdem);
        String mensagem = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, "A ordem não deve ser decimal.", "Verificar mensagem exibida na tela após deixar o campo ordem vazio");
        click(botaoOk);
        tempo();
        tempo();
        click(botaoSalvar);

        String mensagemEsperada = "Campo obrigatório";
        String nome = getText(mensagemObrigatorioNome);
        String sigla = getText(mensagemObrigatorioSigla);
        String unidade = getText(mensagemObrigatorioUn);
        String ordem = getText(mensagemObrigatorioOrdem);
        String grupo = getText(mensagemObrigatorioGrupo);
        Assert.assertEquals(nome, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo nome durante a edição do nutriente");
        Assert.assertEquals(sigla, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo sigla durante a edição do nutriente");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo unidade durante a edição do nutriente");
        Assert.assertEquals(ordem, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo ordem durante a edição do nutriente");
        Assert.assertEquals(grupo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo grupo durante a edição do nutriente");
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void camposDesabilitadosAddNutriente() {
        tempo();
        tempo();
        click(botaoAdicionar);

        boolean fatorCalcCaloria = returnIfElementIsEnabled(campoFatCalcCaloria);
        boolean eCaloria = returnIfElementIsEnabled(inputCheckBoxECaloria);
        boolean calcCaloria = returnIfElementIsEnabled(inputCheckBoxCalCaloria);
        boolean impressao = returnIfElementIsEnabled(inputCheckBoxImpressao);

        Assert.assertEquals(fatorCalcCaloria, false, "Verificar se o campo 'fator cálc caloria' está habilitado");
        Assert.assertEquals(eCaloria, false, "Verificar se o check-box 'é caloria' está habilitado");
        Assert.assertEquals(calcCaloria, false, "Verificar se o check-box 'cál. caloria' está habilitado");
        Assert.assertEquals(impressao, true, "Verificar se o check-box 'impressão' está habilitado");

        impressao = returnIfElementIsSelected(inputCheckBoxImpressao);
        Assert.assertEquals(impressao, false, "Verificar se por padrão ao adicionar um nutriente, o check-box impressão já está selecionado");
        click(checkBoxImpressao);
        impressao = returnIfElementIsSelected(inputCheckBoxImpressao);
        Assert.assertEquals(impressao, true, "Verificar se após clichar no check-box impressão o mesmo passa a estar selecionado");
    }

    public void tentarAdicionarCodigoExistente() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNome, "LIPÍDIOS");
        sendKeys(campoSigla, "LIP");
        click(botaoCampoUn);
        sendKeys(campoProcurarUnidade, "MILIGRAMA");
        click(unMiligrama);
        clicarCampoSelecionarValor(campoGrupo, grupoGorduras);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um nutriente com código que já existe");
        click(botaoOk);
        tempo();
        click(botaoCancelar);
    }

    public void tentarExcluirNutriRegistroFilho() {
        preencherCampoProcurarTelaInicial("001");
        click(botaoExcluirNutrienteLinha1);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o nutriente");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que o registro possuí registros filhos");
        click(botaoOk);

        String codigo = getText(codigoNutrienteLinha1);
        Assert.assertEquals(codigo, "001", "Verificar se o código do nutriente que possuí registros filhos não foi removido");
    }

    private void retornarValeresDoNutrienteAntesEdicao() {
        click(botaoEditarNutrienteLinha1);
        clearAndSendKeys(campoNome, "CARBOIDRATOS COMPLEX");
        clearAndSendKeys(campoSigla, "CC");
        click(botaoCampoUn);
        click(botaoCampoUn);
        sendKeys(campoProcurarUnidade, "MILIGRAMA");
        click(unMiligrama);
        clearAndSendKeys(campoOrdem, "20");
        clicarCampoSelecionarValor(campoGrupo, grupoCarboidratos);
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso exibida no canto superior direito, após editar o nutriente");
        click(botaoVoltar);
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            tempo();
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }


}
