package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MapaDeProducaoFlows;
import com.javaseleniumtemplate.pages.MapaDeProducaoPage;
import org.testng.annotations.Test;

public class MapaDeProducaoTests extends TestBase {

    LoginFlows loginFlows;
    MapaDeProducaoFlows mapaDeProducaoFlows;

    @Test
    public void MapaDeProducao(){
        String DTINICIAL = "01/12/2023";
        String DTFINAL = "30/12/2023";

        loginFlows = new LoginFlows();
        mapaDeProducaoFlows = new MapaDeProducaoFlows();

        loginFlows.efetuarLogin();
        mapaDeProducaoFlows.acessaRelMapaProducao();
        mapaDeProducaoFlows.emitirRelatorio(DTINICIAL,DTFINAL);
        mapaDeProducaoFlows.emiteQuebraDePagina();

    }

}
