package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.AprovacaoCardapioMatrizPage;
import sun.security.krb5.internal.APOptions;

public class AprovacaoCardapioMatrizFlows {

    AprovacaoCardapioMatrizPage aprovacaoCardapioMatrizPage;

    public AprovacaoCardapioMatrizFlows(){
        aprovacaoCardapioMatrizPage = new AprovacaoCardapioMatrizPage();}

    public void acessarTela(){aprovacaoCardapioMatrizPage.acessaTela();}

    public void realizaFiltros(String filtraAgrupamento,String tipoFiltro){aprovacaoCardapioMatrizPage.realizarFiltro(filtraAgrupamento, tipoFiltro);}

    public void aprovaCardapio(){aprovacaoCardapioMatrizPage.aprovaCardapio();}

    public String validaDataAprovacao(){return aprovacaoCardapioMatrizPage.retornaDataAprovacao();}

    public String validaDataAprovacaoCard(){return aprovacaoCardapioMatrizPage.retornaDataAprovacaoCard();}

    public void validaCamposObrigatorios(){aprovacaoCardapioMatrizPage.validaCamposObrigatorios();}

    public String campoObrigatorioUnidade(){return aprovacaoCardapioMatrizPage.retornaCampoObrigatorioUnidade();}

    public String campoObrigatorioServico(){return aprovacaoCardapioMatrizPage.retornaCampoObrigatorioServico();}

    public String campoObrigatorioUCusto(){return aprovacaoCardapioMatrizPage.retornaCampoObrigatorioTipoCusto();}

    public String campoObrigatorioCardapio(){return aprovacaoCardapioMatrizPage.retornaCampoObrigatorioCardadio();}

    public void aprovarTodos(){aprovacaoCardapioMatrizPage.aprovaTodosCardapios();}

    public void cancelarAprovacao(){aprovacaoCardapioMatrizPage.cancelaAprovacao();}



}
