package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.ElaboraCardapioPage;

public class ElaboracaoCardapioFlows {
    ElaboraCardapioPage elaboracaoCardapio;

    public ElaboracaoCardapioFlows(){elaboracaoCardapio = new ElaboraCardapioPage();}

    public void NavegaElaboracaoCardapio(){
      elaboracaoCardapio.clicaMenu();
      elaboracaoCardapio.buscaTelaElaboracao();

    }

    public String validarAcessoTela(){return elaboracaoCardapio.validaAcessoTela();}

    public void limpaCamposFiltro(){elaboracaoCardapio.limparCamposTela();}

    public String msgCampoObrigatrioUnidade(){return elaboracaoCardapio.mensagemCampoUnidade();}

    public String msgCampoObrigatrioServico(){return elaboracaoCardapio.mensagemCampoServico();}

    public String msgCampoObrigatrioMesCard(){return elaboracaoCardapio.mensagemCampoMesCard();}

    public String msgCampoObrigatrioCustoPla(){return elaboracaoCardapio.mensagemCustoPla();}

    public String msgCampoObrigatrioCustoReal(){return elaboracaoCardapio.mensagemCustoReal();}

    public String msgCampoObrigatrioDataRef(){return elaboracaoCardapio.mensagemCampoDataRef();}

    public void filtrarUnidade(String CDFILIAL){ elaboracaoCardapio.filtrarUnidade(CDFILIAL);}

    public void filtrarServico(String CDSERVICO){
        elaboracaoCardapio.filtrarServico(CDSERVICO);

    }

    public void mesCardapio(){
        elaboracaoCardapio.definePeriodo();
    }

    public void montagemCardadioAtraves(String tipoMontagem){elaboracaoCardapio.montaCardapioAtraves(tipoMontagem);}

    public void confirmaFiltroCardapio(){
        elaboracaoCardapio.confirmaFiltro();
    }

    public void custoCardapioPlanejado(){
        elaboracaoCardapio.custoCardapioPla();
    }

    public void custoCardapioRealizado(){
        elaboracaoCardapio.custoCardapioReal();
    }

    public void custoComBaseData(String CDEXIBECUSTO, String DATATIPOCUSTO,String DTREFERENCIA){
        elaboracaoCardapio.custoCombaseNaData(CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
    }

    public void elaboraCardapio(String NMPRATO1,String NMPRATO2,String NMPRATO3 ){
        elaboracaoCardapio.elaboraCardapio(NMPRATO1,NMPRATO2,NMPRATO3);
    }

    public String validaCorPratoCardapio(){return elaboracaoCardapio.retornaCorPratoCardapio();}

    public void analiseDeCorCardapio(){elaboracaoCardapio.analisarCorCardapio();}

    public void analiseDeCustos(){
        elaboracaoCardapio.analiseCustos();
    }

    public void atualizaDataReferenciaCusto(String CDSERVICO, String DATAREF){
        elaboracaoCardapio.atualizaDataReferencia(CDSERVICO,DATAREF);
    }

    public void atualizaDataRecalculoCusto(String CDSERVICO,String DTREFERENCIA){
        elaboracaoCardapio.atualizaDataRecalculoCusto(CDSERVICO,DTREFERENCIA);
    }

    public void calcularNutrientes(){
        elaboracaoCardapio.consultaNutrientes();
    }

    public void copiaPratosComensais(String CDPRATO,String COMENSAISSEG,String COMENSAISTER, String COMENSAISQUA, String COMENSAISQUI, String COMENSAISSEX, String COMENSAISSAB, String COMENSAISDOM, String COMENSAISFER){
        elaboracaoCardapio.copiarPrato(CDPRATO,COMENSAISSEG,COMENSAISTER,COMENSAISQUA,COMENSAISQUI,COMENSAISSEX,COMENSAISSAB,COMENSAISDOM,COMENSAISFER);
    }

    public void copiarComensais(String CDPRATO){
        elaboracaoCardapio.copiarComensais(CDPRATO);
    }

    public void exportaCardapio(String CDSERVICO,String TIPOACAO, String CDSERVDESTINO){
        elaboracaoCardapio.exportarCardapio(CDSERVICO,TIPOACAO,CDSERVDESTINO);
    }

    public void importaCardapioDia(String CDFILIAL, String CDSERVICO, String CDSERVICOORIGEM, String DTINICIAL, String DTFINAL, String DTDESTINO, String TIPOCOPIA){
        elaboracaoCardapio.importarCardapioDia(CDFILIAL,CDSERVICO,CDSERVICOORIGEM,DTINICIAL,DTFINAL,DTDESTINO,TIPOCOPIA);
    }

    public String msgConfirmaExclusao(){return elaboracaoCardapio.msgExcluidoSucesso();}

    public void importarTipoDePrato(String CDFILIAL, String CDSERVICO, String DTINICIO){
        elaboracaoCardapio.importarTipoPrato(CDFILIAL, CDSERVICO,DTINICIO);
    }

    public void excluirCardapioPeriodo(String DTINICIAL, String DTFINAL){
        elaboracaoCardapio.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
    }

    public void inverterPratosDia(String NMPRATO,String NMPRATO01, String DTINI, String DTFIM){
        elaboracaoCardapio.invertarPrato(NMPRATO,NMPRATO01,DTINI,DTFIM);
    }

    public String validaPratoInvertido01(){return elaboracaoCardapio.msgEsperadaPrato_01();}

    public String validaPratoInvertido02(){return elaboracaoCardapio.msgEsperadaPrato_02();}

    public void excluirPratoDia(){
        elaboracaoCardapio.excluirPrato();
    }

    public void informacaoNutricionaoPrato(){
        elaboracaoCardapio.informacaoNutricional();
    }

    public void adicionaProdutoReceita(String tipoReceita){elaboracaoCardapio.adicionarProdutoReceita(tipoReceita);}

    public void validaCadastroProdutoIgual(String tipoReceita){elaboracaoCardapio.validaCadastroProdutoIgual(tipoReceita);}

    public String validaProdutoCadastrado(String tipoReceita){return elaboracaoCardapio.retornarProdutoCadastrado(tipoReceita);}

    public void revisaoReceitaLocal(String acaoRevisao){
        elaboracaoCardapio.revisaoReceitaLocal(acaoRevisao);}

    public void revisaoDeReceitaPorServico(String acaoRevisao){
        elaboracaoCardapio.revisaoReceitaPorServico(acaoRevisao);
    }

    public void configurarCardapio(){
        elaboracaoCardapio.configurarCardapio();

    }

    public void validaCampo(){elaboracaoCardapio.validarCamposObrigatorios();}

    public String validarPratoCardapio(){return elaboracaoCardapio.validaPratoCardapio();}




}
